
#include <stdio.h>
#include <stdlib.h>
#include "file.h"

 static long lastrecno = 0;
 static FILE *fptr;
 static int recsize;

 void openfile(char *filename, int in_recsize)
	{
	recsize = in_recsize;

	if((fptr = fopen(filename, "r+b")) != NULL)
		{
		fseek(fptr, 0L, SEEK_SET);
		fscanf(fptr,"%ld", &lastrecno);
		}
	else 
		if((fptr = fopen(filename, "w+b")) != NULL)
			{
			lastrecno = 0L;
			fwrite(" ", 1, recsize, fptr);  
			}
		else {
			printf("file open error\n");
			exit(1);
			}
	}

 void closefile(void)
	{
	fseek(fptr,0L, SEEK_SET);
	fprintf(fptr,"%ld", lastrecno);
	fclose (fptr);
	}

 void writerec(char *recptr,long recno)
	{
	fseek(fptr, recno * recsize , SEEK_SET);
	fwrite(recptr, recsize, 1, fptr);
	}

 long readrec(char *recptr, long recno)
	{
	long res;
	fseek(fptr, recno * recsize , SEEK_SET);
	res = fread (recptr, recsize, 1, fptr);
	return(res);
	}

 long getlastrecno(void)
	{
	return (lastrecno);
	}

 long setnextrecno(void){
	lastrecno++;
	return (lastrecno);
	}


