
#include <stdio.h>
#include <stdlib.h>

	typedef struct numobj {
			int mynum;
			struct numobj *nextptr;
			} NUMOBJ;

 void printlist(NUMOBJ*);
 NUMOBJ *addobj(NUMOBJ*);
 NUMOBJ *delobj(NUMOBJ*);

 int main(void)
	{
	char choice[2];
	int more = 1;
	NUMOBJ * headptr = 0, *resptr;

	while (more != 0)
		{
		printf("Please enter choice\n");
		scanf("%s", choice);
		switch(choice[0])
			{
			case 'a': 
					resptr = addobj(headptr);
					if (headptr == 0)
						headptr = resptr;
					break;
			case 'p':
					printlist(headptr);
					break;
			case 'd':
					resptr = delobj(headptr);
					if(resptr == 0)
						headptr = 0;
					break;
			case 'q':
					more = 0;
			}
		}
	return 0;
	}

void printlist(NUMOBJ *headptr)
	{
	NUMOBJ *wkptr;

	wkptr = headptr;
	while(wkptr != 0)
		{
		printf("%d\n", wkptr->mynum);
		wkptr = wkptr->nextptr;
		}
	}

NUMOBJ *addobj(NUMOBJ *headptr)
	{
	NUMOBJ *newptr;
	NUMOBJ *wkptr;

		newptr = (NUMOBJ *) malloc(sizeof(NUMOBJ));
		newptr->nextptr = 0;
		printf("Please enter new number\n");
		scanf("%d", &newptr->mynum);

		if(headptr == 0)
			{
			return newptr;
			}
		else
			{
			wkptr= headptr;
			while (wkptr->nextptr != 0)
				wkptr = wkptr->nextptr;
			wkptr->nextptr = newptr;
			return newptr;
			}
	}

NUMOBJ *delobj(NUMOBJ *headptr)
	{
	NUMOBJ*prevptr;
	NUMOBJ*wkptr;

	if(headptr != 0)
		{
		if(headptr->nextptr == 0)
			{
			free(headptr);
			return 0;
			}
			else
			{
			wkptr=prevptr= headptr;
			while (wkptr->nextptr!=0)
				{
				prevptr = wkptr;
				wkptr=wkptr->nextptr;
				}
			prevptr->nextptr = 0;
			free (wkptr);
			return prevptr;
			}
		}
	}



