
#include <stdio.h>
#include <stdlib.h>

	typedef struct node {
			int mynum;
			struct node *lptr;
			struct node *rptr;
			} NODE;

void printnodes(NODE*);
void printorder(NODE*);
NODE *addnode(NODE*, int);

 int main(void)
	{
	char choice[2];
	int more = 1, newnum;
	NODE *rootptr = 0, *resptr;

	while (more != 0)
		{
		printf("Please enter choice\n");
		scanf("%s", choice);
		switch(choice[0])
			{
			case 'a': 
					printf("Enter number\n");
					scanf ("%d", &newnum);
					resptr = addnode(rootptr,newnum);
					if(rootptr == 0)
						rootptr = resptr;
					break;
			case 'p':
					printorder(rootptr);
					break;
			case 'n':
					printnodes(rootptr);
					break;
			case 'q':
					more = 0;
			}
		}
	return 0;
	}


void printorder(NODE *nodeptr)
	{
	if(nodeptr != 0)
		{
		printorder(nodeptr->lptr);
		printf("%d\n", nodeptr->mynum);
		printorder(nodeptr->rptr);
		}
	}

void printnodes(NODE *nodeptr)
	{
	if(nodeptr != 0)
		{
		printf("%d\n", nodeptr->mynum);
		printnodes(nodeptr->lptr);
		printnodes(nodeptr->rptr);
		}
	}

NODE *addnode(NODE *nptr, int num)
	{
	NODE *newptr = 0, *resptr;

	if(nptr == 0)
		{
		newptr = (NODE*) malloc(sizeof(NODE));
		newptr->mynum = num;
		newptr->rptr = 0;
		newptr->lptr = 0;
		return newptr;
		}
	else
		{
		if (num < nptr->mynum)
			{
			resptr = addnode(nptr->lptr, num);
			if(resptr != 0)
				nptr->lptr = resptr;
			}
		else
			if(num > nptr->mynum)
				{
				resptr = addnode(nptr->rptr, num);
				if(resptr != 0)
					nptr->rptr = resptr;
				}
			return 0;
		}
	}



