
#include <stdio.h>
#include <stdlib.h>

	typedef struct {
				char name[100];
				int id;
				float salary;
				}	EMP;

void addrecord(FILE*);
void updaterecord (FILE*);
void printrev(FILE*);

int main(void)
	{
	char choice[2];
	FILE *fileptr;
	int more = 1;

	if((fileptr = fopen("empfile1", "r+b")) == NULL)
		if((fileptr=fopen("empfile1","w+b"))==NULL)
			{
			printf("File could not be opened\n");
			exit(1);
			}

	while (more)
		{
		printf("Please enter choice: ");
		scanf("%s", choice);

		switch(choice[0])
			{
			case 'a': 
				addrecord(fileptr);
				break;
			case 'u': 
				updaterecord(fileptr); 
				break;
			case 'p': 
				printrev(fileptr); 
				break;
			case 'q': 
				more = 0;
				break;
			}
		}
	fclose(fileptr);
	return 0;
	}


void addrecord(FILE *fileptr)
	{
	EMP emp;

	printf ("Please enter all three fields: ");
	scanf("%s%d%f",emp.name,&emp.id,&emp.salary);
	fseek(fileptr, 0L, SEEK_END);
	fwrite(&emp, sizeof(EMP), 1, fileptr); 
	}


void updaterecord (FILE  *fileptr)
	{
	EMP emp;
	long recordid;

	printf("Please enter record number: ");
	scanf("%ld", &recordid);
	fseek(fileptr, recordid*sizeof(EMP),SEEK_SET);
	fread(&emp, sizeof(EMP), 1, fileptr);

	printf("%s %d %.2f\n",emp.name,emp.id,emp.salary);
	printf ("Please enter all three fields: ");
	scanf("%s%d%f",emp.name,&emp.id,&emp.salary);

	fseek(fileptr, recordid*sizeof(EMP),SEEK_SET);
	fwrite(&emp, sizeof(EMP), 1, fileptr); 
	}


void printrev(FILE *fileptr)
	{
	EMP emp;
	long recnums, filesize, i, curnum;

	fseek(fileptr, 0L, SEEK_END);
	filesize = ftell(fileptr);
	recnums = filesize / sizeof(EMP);

	for(i = (recnums-1); i >= 0; i--)
		{
		fseek(fileptr, i*sizeof(EMP),SEEK_SET);
		curnum = ftell(fileptr);
		fread(&emp, sizeof(EMP), 1, fileptr);
		printf("\nRecord Byte Offset = %ld",curnum);
		printf("\nRecord Number = %ld\n",i);
		printf("%s %d %.2f\n",emp.name,emp.id,emp.salary);
		}
	}


