
	struct bookrec {	/* Book structure */
			char title[30];
			int  year;
			float price;
			} ;

	class booklib {
		private:
			int nextbook;
			int maxbooks;
			int Year;
			bookrec *books;
			void calc_price();
 		public:
			booklib (int, int);
			~booklib();
 			void add_book();
			void output_books();
			void menu();
 		};

  booklib::booklib(int max=10, int yr= 0)
	{
	nextbook = 0;
	maxbooks = max;
	Year = yr;
	books = new bookrec[maxbooks];
	}

  booklib::~booklib()
	{
	delete books;
	}

 void booklib::add_book()
	{
	if(nextbook < maxbooks)
		{
		printf("\nPlease enter title: ");
		scanf("%*[\n\t ]%[^\n]s", books[nextbook].title);
		printf("Please enter year published: ");
		scanf("%d", &books[nextbook].year);
		printf("Please enter book price: ");
		scanf("%f", &books[nextbook].price);
		calc_price();
		nextbook++;
		}
	  else
	  	printf("Library is full\n");
	}

 void booklib::calc_price()
	{
	if (books[nextbook].year < Year)
		books[nextbook].price *= 0.5; 
	}

 void booklib::output_books()
	{
	int i;
	
	for(i=0; i < nextbook; i++)
		{
		printf("\n\n Book Record \n");
		printf("\t TITLE: %s \n", books[i].title);
		printf("\t YEAR : %d \n", books[i].year);
		printf("\t PRICE: %.2f \n\n", books[i].price);
		}
	}

void booklib::menu()
		{
		printf("a. add books to library\n");
		printf("p. print books in library\n");
		printf("q. quit library\n");
		}



