		
     struct EMP {
		char name[100];
		long id;
		float salary;
		} ;

class  empfile : public filerec, public tree {
		void output_rec(EMP);
		void input_rec(EMP*);
       protected:
		void build_index(void);
		virtual void printrec(long);
	public:
		empfile(char *);
		void find_emp(void);
		void add_rec(void);
		void print_file(void);
		void menu(void);
	};

 empfile::empfile(char *fname): filerec((long)sizeof(EMP), fname)
		{
		if(getlastrecno() > 0)
		  build_index();
		}

 void empfile::build_index(void)
		{
		long i, lastrec;
		EMP emprec;
		lastrec = getlastrecno();
		for (i = 1; i <= lastrec ; i++)
			{
			readrec((char*) &emprec, i);
			addindex(emprec.name, emprec.id);
			}
		}

	void empfile::add_rec(void)
		{
		EMP emprec;

		input_rec(&emprec);
		emprec.id = setnextrecno();
		writerec(&emprec,emprec.id);
		addindex(emprec.name, emprec.id);
		}

	void empfile::input_rec(EMP *emptr)
		{
		printf("\nPlease enter name: ");
		scanf("%*[\n\t ]%[^\n]s", emptr->name);  
	   /*	scanf("%s", emptr->name);    */
		printf("\nplease enter employee salary: ");
		scanf("%f", &emptr->salary);
		}

	void empfile::print_file(void)
		{
		long i, lastrec;

		lastrec = getlastrecno();
		for (i = 1; i <= lastrec ; i++){
			printrec(i);
			}
		}

	void empfile::printrec(long recno)
		{
		EMP out_emp;

		readrec((char*) &out_emp, recno);
		printf("\n\n Employee Record \n");
		printf("\n\t NAME  : %s \n", out_emp.name);
		printf("\n\t ID    : %ld \n", out_emp.id);
		printf("\n\t SALARY: %f \n\n", out_emp.salary);
		}

	void empfile::find_emp(void)
		{
		char empname[100];
		long recno;

		printf("Please enter employee name: ");
		scanf("%*[\n\t ]%[^\n]s", &empname);

		recno = findrec(empname);
		
		if (recno != 0)
			printrec(recno);
		else
			printf("Record not found\n");
		}

	void empfile::menu(void)
		{
		printf("\nEmployee Records Menu\n");
		printf("\na = add a record\n");
		printf("f = find a record\n");
		printf("p = prints a records\n");
		printf("i = print index\n");
		printf("r = print record file\n");
		printf("m = display menu\n");
		printf("q = quit program\n\n");
		}



