
class filerec {
	private:
		FILE  *fptr;
		long recsize;
		long lastrecno;
	protected:
		filerec(long, char *);
		~filerec(void);
		long readrec(void *, long);
		void writerec(void *, long);
		void reset(void);
		long setnextrecno(void);
		long getlastrecno(void);
		};

 filerec::filerec(long size, char *filename)
		{
		recsize = size;

		if ( (fptr = fopen(filename, "r+b")) != NULL){
			fseek(fptr, 0L, 0);
			fscanf(fptr, "%ld", &lastrecno);
			}
		  else 
			if ( (fptr = fopen(filename, "w+b")) != NULL){
				lastrecno = 0L;
				}
			  else {
				printf("file open error\n");
				exit(1);
				}
		}

 filerec::~filerec(void)
		{
		fseek(fptr,0L, 0);
		fprintf(fptr,"%ld", lastrecno);
		fclose (fptr);
		}

void filerec::writerec(void *buf, long recno)
		{
		fseek(fptr, (recno * recsize), 0);
		fwrite(buf, recsize, 1, fptr);
		}

long filerec::readrec(void *buf, long recno)
		{
		long res;

		fseek(fptr, (recno * recsize) , 0);
		res = fread (buf, recsize, 1, fptr);
		return(res);
		}
		
long filerec::getlastrecno(void)
		{
		return (lastrecno);
		}

long filerec::setnextrecno(void)
		{
		lastrecno++;
		return (lastrecno);
		}
void filerec::reset(void)
		{
		fseek (fptr, 0L, 0);
		}


