
	struct NODE{
			long recno;
			char key[100];
			NODE *lptr;
			NODE *rptr;
			} ;

	class tree {
	  private:
		NODE *rootptr;
		void printorder(NODE*);
		void printnodes(NODE*);
		long findnode(NODE *, char*);
		NODE *addnode(NODE*, char*, long);
	  protected:
		tree(void);
		void addindex(char*, long);
		virtual void printrec(long);
	  public:
		long findrec(char*);
		void printrecords(void);
		void printindex(void);
		};

	tree::tree(void)
	{
	rootptr = 0;
	}
		
void tree::printrec(long recno)
	{
	printf("%ld\n", recno);
	}

 void tree::printrecords (void)
	{
	printorder(rootptr);
	}

 void tree::printorder(NODE *nodeptr)
	{
	if(nodeptr != 0)
		{
		printorder(nodeptr->lptr);
		printrec(nodeptr->recno); 
		printorder(nodeptr->rptr);
		}
	}

 void tree::printindex(void)
	{
	printnodes(rootptr);
	}

 void tree::printnodes(NODE *nodeptr)
	{
	if(nodeptr != 0)
		{
		printf("%d\n", nodeptr->recno);
		printf("%s\n\n", nodeptr->key);
		printnodes(nodeptr->lptr);
		printnodes(nodeptr->rptr);
		}
	}

 void tree::addindex(char *key, long recno)
	{
	NODE *resptr;
	
	resptr = addnode(rootptr, key, recno);
	if(rootptr == 0)
		rootptr = resptr;
	}

 NODE *tree::addnode(NODE *nptr, char *newkey, long recno)
	{
	NODE *newptr = 0, *resptr;

	if(nptr == 0)
		{
		newptr = (NODE*) malloc(sizeof(NODE));
		strcpy (newptr->key, newkey);
		newptr->recno = recno;
		newptr->rptr = 0;
		newptr->lptr = 0;
		return newptr;
		}
	else
		{
		if(strcmp(newkey, nptr->key) < 0)
			{
			resptr = addnode(nptr->lptr,newkey,recno);
			if(resptr != 0)
				nptr->lptr = resptr;
			}
		else
			if(strcmp(newkey, nptr->key) > 0)
				{
			resptr=addnode(nptr->rptr,newkey,recno);
				if(resptr != 0)
					nptr->rptr = resptr;
				}
		return 0;
		}
	}

 long tree::findrec(char *key)
	{
	long recno;

	recno = findnode(rootptr, key);
	return recno;
	}

 long tree::findnode(NODE *nptr, char *key)
	{
	long recno;
	
	if(nptr == 0)
		{
		return 0;
		}
	  else
		{
		if(strcmp(key, nptr->key) == 0)
			return nptr->recno;
		else
			if(strcmp(key, nptr->key) < 0)
				recno = findnode(nptr->lptr,key);
			else
				if(strcmp(key, nptr->key) > 0)
					recno = findnode(nptr->rptr,key);
		return recno;
		}
	}


