
#include <stdio.h>
#include "emp.h"
#include "file.h"

#define NAMELEN 100

/* EMP structure */
	typedef  struct emp_type {
		char name[NAMELEN];
		long id;
		float salary;
		} EMP;

 static EMP input_rec(void);
 static void output_rec(EMP);
static void selectfield(EMP *);
static void menurec(EMP );

 void open_empfile(char* filename)
	{
	openfile(filename, sizeof(EMP));
	}

 void close_empfile(void)
	{
	closefile();
	}

void add_rec(void)
	{
	EMP emprec;
	
	emprec = input_rec();
	emprec.id = setnextrecno();
	writerec((char*)&emprec, emprec.id);
	}

 static EMP input_rec(void)
		{
		EMP in_emp;

		printf("\nPlease enter last name: ");
		scanf("%*[\n\t ]%[^\n]s", in_emp.name);
		printf("Please enter salary: ");
		scanf("%f", &in_emp.salary);
		return(in_emp);
		}

void print_recs(void)
		{
		EMP emprec;
		long i, lastrec;

		lastrec = getlastrecno();
		for (i = 1; i <= lastrec ; i++){
			readrec((char*)&emprec,i);
			output_rec(emprec);
			}
		}

 static void output_rec(EMP out_emp)
		{
		printf("\n Employee Record \n");
		printf("\t NAME  : %s\n", out_emp.name);
		printf("\t ID    : %ld\n", out_emp.id);
		printf("\t SALARY: %.2f\n", out_emp.salary);
		}


void findrec(void)
		{
		long id;
		EMP employee;
		
		printf("Please enter record id: ");
		scanf("%ld", &id);
		readrec((char*)&employee, id);
		output_rec(employee);
		}

void updaterec(void)
	{
	long recno;
	EMP employee;
	
	printf("Please enter record id: ");
	scanf("%ld", &recno);
	readrec((char*)&employee, recno);
	selectfield(&employee);
	writerec((char*)&employee,recno);
	}

static void selectfield(EMP *emptr)
		{
		int more = 0, response; 

		while (more == 0){
			menurec( *emptr );

			printf("\nPlease enter choice: ");
			scanf("%1s", &response);
			while(getchar() != '\n');

			switch(response){
				case  '1':
					printf("enter new name: ");
					scanf("%*[\n\t ]%[^\n]s",emptr->name);
					break;
				case  '2':
					printf("\n enter employee id:");
					scanf("%d", &emptr->id);
					break;
				case  '3':
	                       	        printf("Please enter salary: ");
					scanf("%f", &emptr->salary);
					break;
				case  'q':
					more = 1;
					break;
				default:
					printf("invalid input\n");
				}
			}
		}

static void menurec(EMP out_emp)
	{
	printf("\n\n Employee Record \n");
	printf("\n\t 1.NAME  : %s \n", out_emp.name);
	printf("\n\t 2.ID    : %d \n", out_emp.id);
	printf("\n\t 3.SALARY: %f \n", out_emp.salary);
	printf("\n Choose field to be changed");
	}



