
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

	typedef struct strobj {
			char *strptr;
			struct strobj *nextptr;
			} STROBJ;

STROBJ *insertobj(STROBJ*, char*);
void printlist(STROBJ *);

int main(void)
	{
	STROBJ *headptr = 0, *resptr;
	int i;
	char mystrings[3][10] = { "Virgil","Dickens","Poe"};

	for(i=0; i<3; i++)
		{
		resptr = insertobj(headptr, mystrings[i]);
		if(resptr != 0)
				headptr = resptr;
		}
	printlist(headptr);

	return 0;
	}

STROBJ *insertobj(STROBJ *headptr, char *str)
	{
	STROBJ *newptr;
	STROBJ *wkptr, *prevptr;

	newptr = (STROBJ *) malloc(sizeof(STROBJ));
	newptr->strptr = str;;

	prevptr = 0;
	wkptr = headptr;
	while((wkptr!=0) && (strcmp(str,wkptr->strptr)>0))
		{
		prevptr = wkptr;
		wkptr=wkptr->nextptr;
		}

	newptr->nextptr = wkptr;
	if(prevptr == 0)
		return newptr;	/*insert at head of list*/
	else{
		prevptr->nextptr = newptr;
		return 0;
		}
	}

void printlist(STROBJ *headptr)
	{
	STROBJ *wkptr;

	wkptr = headptr;
	while(wkptr != 0)
		{
		printf("%s\n", wkptr->strptr);
		wkptr = wkptr->nextptr;
		}
	}

